import { useEffect } from 'react';

declare const useIsomorphicEffect: typeof useEffect;

declare function usePrevious<T>(state: T): T | undefined;

declare function usePreviousDistinct<T>(value: T, compare?: (prev: T | undefined, next: T) => boolean): T | undefined;

interface EventEmitter {
    on: (type: string, listener: () => void) => void;
    off: (type: string, listener: () => void) => void;
}
declare function useBusiness<E extends EventEmitter, R>(emitter: E, events: string[], evalFn: (emitter: E) => R): R;
declare function useBusiness<E extends EventEmitter, A, R>(emitter: E, events: string[], evalFn: (emitter: E, args: A) => R, args: A): R;

export { useBusiness, useIsomorphicEffect, usePrevious, usePreviousDistinct };
